(***************************************
* AutoRun plugin for FAR manager.
* Allows to execute autorun.inf files
* Copyright (c) 2001, Vasily V. Moshninov
*****************************************)
library autorun;

uses windows, ShellAPI;

const
  s1: string = 'AutoRun plugin for FAR manager. version 1.2';
  s2: string = 'Copyright (c) 2001, Vasily V. Moshninov';

function StrIComp(Str1, Str2: PChar): integer; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     EDI,EDX
        MOV     ESI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     EAX,EAX
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,EDX
        XOR     EDX,EDX
@@1:    REPE    CMPSB
        JE      @@4
        MOV     AL,[ESI-1]
        CMP     AL,'a'
        JB      @@2
        CMP     AL,'z'
        JA      @@2
        SUB     AL,20H
@@2:    MOV     DL,[EDI-1]
        CMP     DL,'a'
        JB      @@3
        CMP     DL,'z'
        JA      @@3
        SUB     DL,20H
@@3:    SUB     EAX,EDX
        JE      @@1
@@4:    POP     ESI
        POP     EDI
end;

function StrEnd(Str: PChar): PChar; assembler;
asm
        MOV     EDX,EDI
        MOV     EDI,EAX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        LEA     EAX,[EDI-1]
        MOV     EDI,EDX
end;

function OpenFilePlugin(FileName: PChar; Data: pointer; DataSize: integer): THandle; stdcall;

const
  AUTORUN = 'autorun.inf';

var
  P: PChar;
  ei: TShellExecuteInfo;
  cCmd: array[0..1024] of char;
begin
// ᥣ 頥 INVALID_HANDLE_VALUE
  result:= INVALID_HANDLE_VALUE;
//     .  뢠  ᮧ  䠩.
  if FileName = nil then
    Exit;
//    OEM.    ANSI
  OemToChar(FileName, cCmd);
  P:= StrEnd(cCmd) - Length(AUTORUN);
  if P < cCmd then
    Exit;
  if StrIComp(P, AUTORUN) <> 0 then
    Exit;
  if GetPrivateProfileString('autorun', 'open', nil, cCmd, sizeof(cCmd), cCmd) = 0 then
    Exit;
  result:= THandle(-2);
  P:= cCmd;
  if P^ = '"' then
  //   窠.
  begin
    Inc(P);
    while not (P^ in [#0, '"']) do
      Inc(P);
    if P^ <> #0 then
      Inc(P);
  end
  else
    while not (P^ in [#0, #9, #32]) do
      Inc(P);
  if P^ <> #0 then
  begin
    P^:= #0;
    Inc(P);
  end;
  FillChar(ei, sizeof(ei), 0);
  ei.cbSize:= sizeof(ei);
  ei.lpFile:= cCmd;
  ei.lpParameters:= P;
  ei.nShow:= SW_SHOWNORMAL;
  SetFileApisToANSI;
  ShellExecuteEx(@ei);
  SetFileApisToOEM;
end;

exports
  OpenFilePlugin;

end.
